Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2232)
@@ -2759,54 +3296,113 @@
         IMPLICIT NONE
 
-        INTEGER(iwp) ::  i,j,k,l,kw                      !< running indices
+        INTEGER(iwp) ::  i,j,k,l,kw, m                      !< running indices
 
         REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wtend  !< tendency
 
-                                               
-        DO l = startenergy, endenergy
-!--         calculate frequently used parameters
-            k = surfl(iz,l)
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-
-            !
-!--         prognostic equation for ground/wall/roof temperature t_wall
-            wtend(:) = 0.0_wp
-            wtend(nzb_wall) = (1.0_wp/rho_c_wall(nzb_wall,l)) *                     &
-                       ( lambda_h(nzb_wall,l) * ( t_wall(nzb_wall+1,l)              &
-                         - t_wall(nzb_wall,l) ) * ddz_wall(nzb_wall+1,l)            &
-                         + wghf_eb(l) ) * ddz_wall_stag(nzb_wall,l)
+!
+!--     For horizontal surfaces                                   
+        DO  m = 1, surf_usm_h%ns
+!
+!--        Obtain indices
+           i = surf_usm_h%i(m)            
+           j = surf_usm_h%j(m)
+           k = surf_usm_h%k(m)
+!
+!--        prognostic equation for ground/roof temperature t_wall_h
+           wtend(:) = 0.0_wp
+           wtend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_wall(nzb_wall,m)) *    &
+                                      ( surf_usm_h%lambda_h(nzb_wall,m) *      &
+                                        ( t_wall_h(nzb_wall+1,m)               &
+                                        - t_wall_h(nzb_wall,m) ) *             &
+                                        surf_usm_h%ddz_wall(nzb_wall+1,m)      &
+                                      + surf_usm_h%wghf_eb(m) ) *              &
+                                        surf_usm_h%ddz_wall_stag(nzb_wall,m)
             
-            DO  kw = nzb_wall+1, nzt_wall
-                wtend(kw) = (1.0_wp/rho_c_wall(kw,l))                               &
-                              * (   lambda_h(kw,l)                                  &
-                                 * ( t_wall(kw+1,l) - t_wall(kw,l) )                &
-                                 * ddz_wall(kw+1,l)                                 &
-                              - lambda_h(kw-1,l)                                    &
-                                 * ( t_wall(kw,l) - t_wall(kw-1,l) )                &
-                                 * ddz_wall(kw,l)                                   &
-                              ) * ddz_wall_stag(kw,l)
+           DO  kw = nzb_wall+1, nzt_wall
+               wtend(kw) = (1.0_wp / surf_usm_h%rho_c_wall(kw,m))              &
+                              * (   surf_usm_h%lambda_h(kw,m)                  &
+                                 * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )       &
+                                 * surf_usm_h%ddz_wall(kw+1,m)                 &
+                              - surf_usm_h%lambda_h(kw-1,m)                    &
+                                 * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )       &
+                                 * surf_usm_h%ddz_wall(kw,m)                   &
+                              ) * surf_usm_h%ddz_wall_stag(kw,m)
             ENDDO
 
-            t_wall_p(nzb_wall:nzt_wall,l) = t_wall(nzb_wall:nzt_wall,l)             &
-                                             + dt_3d * ( tsc(2)                     &
-                                             * wtend(nzb_wall:nzt_wall) + tsc(3)    &
-                                             * tt_wall_m(nzb_wall:nzt_wall,l) )   
+           t_wall_h_p(nzb_wall:nzt_wall,m) = t_wall_h(nzb_wall:nzt_wall,m)     &
+                                 + dt_3d * ( tsc(2)                            &
+                                 * wtend(nzb_wall:nzt_wall) + tsc(3)           &
+                                 * surf_usm_h%tt_wall_m(nzb_wall:nzt_wall,m) )   
             
-            !
-!--         calculate t_wall tendencies for the next Runge-Kutta step
-            IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
+!
+!--        calculate t_wall tendencies for the next Runge-Kutta step
+           IF ( timestep_scheme(1:5) == 'runge' )  THEN
+               IF ( intermediate_timestep_count == 1 )  THEN
+                  DO  kw = nzb_wall, nzt_wall
+                     surf_usm_h%tt_wall_m(kw,m) = wtend(kw)
+                  ENDDO
+               ELSEIF ( intermediate_timestep_count <                          &
+                        intermediate_timestep_count_max )  THEN
                    DO  kw = nzb_wall, nzt_wall
-                      tt_wall_m(kw,l) = wtend(kw)
+                      surf_usm_h%tt_wall_m(kw,m) = -9.5625_wp * wtend(kw) +    &
+                                         5.3125_wp * surf_usm_h%tt_wall_m(kw,m)
                    ENDDO
-                ELSEIF ( intermediate_timestep_count <                              &
-                         intermediate_timestep_count_max )  THEN
-                    DO  kw = nzb_wall, nzt_wall
-                        tt_wall_m(kw,l) = -9.5625_wp * wtend(kw) + 5.3125_wp        &
-                                         * tt_wall_m(kw,l)
-                    ENDDO
-                ENDIF
-            ENDIF
+               ENDIF
+           ENDIF
+        ENDDO
+!
+!--     For vertical surfaces     
+        DO  l = 0, 3                              
+           DO  m = 1, surf_usm_v(l)%ns
+!
+!--           Obtain indices
+              i = surf_usm_v(l)%i(m)            
+              j = surf_usm_v(l)%j(m)
+              k = surf_usm_v(l)%k(m)
+!
+!--           prognostic equation for wall temperature t_wall_v
+              wtend(:) = 0.0_wp
+              wtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_wall(nzb_wall,m)) * &
+                                      ( surf_usm_v(l)%lambda_h(nzb_wall,m) *   &
+                                        ( t_wall_v(l)%t(nzb_wall+1,m)          &
+                                        - t_wall_v(l)%t(nzb_wall,m) ) *        &
+                                        surf_usm_v(l)%ddz_wall(nzb_wall+1,m)   &
+                                      + surf_usm_v(l)%wghf_eb(m) ) *           &
+                                        surf_usm_v(l)%ddz_wall_stag(nzb_wall,m)
+            
+              DO  kw = nzb_wall+1, nzt_wall
+                  wtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m))        &
+                           * (   surf_usm_v(l)%lambda_h(kw,m)                  &
+                              * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )&
+                              * surf_usm_v(l)%ddz_wall(kw+1,m)                 &
+                           - surf_usm_v(l)%lambda_h(kw-1,m)                    &
+                              * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )&
+                              * surf_usm_v(l)%ddz_wall(kw,m)                   &
+                              ) * surf_usm_v(l)%ddz_wall_stag(kw,m)
+               ENDDO
+
+              t_wall_v_p(l)%t(nzb_wall:nzt_wall,m) =                           &
+                                   t_wall_v(l)%t(nzb_wall:nzt_wall,m)          &
+                                 + dt_3d * ( tsc(2)                            &
+                                 * wtend(nzb_wall:nzt_wall) + tsc(3)           &
+                                 * surf_usm_v(l)%tt_wall_m(nzb_wall:nzt_wall,m) )   
+            
+!
+!--           calculate t_wall tendencies for the next Runge-Kutta step
+              IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                  IF ( intermediate_timestep_count == 1 )  THEN
+                     DO  kw = nzb_wall, nzt_wall
+                        surf_usm_v(l)%tt_wall_m(kw,m) = wtend(kw)
+                     ENDDO
+                  ELSEIF ( intermediate_timestep_count <                       &
+                           intermediate_timestep_count_max )  THEN
+                      DO  kw = nzb_wall, nzt_wall
+                         surf_usm_v(l)%tt_wall_m(kw,m) =                       &
+                                     - 9.5625_wp * wtend(kw) +                 &
+                                       5.3125_wp * surf_usm_v(l)%tt_wall_m(kw,m)
+                      ENDDO
+                  ENDIF
+              ENDIF
+           ENDDO
         ENDDO
 
@@ -2857,9 +3453,7 @@
 !--    Read user-defined namelist
        READ ( 11, urban_surface_par )
-
 !
 !--    Set flag that indicates that the land surface model is switched on
        urban_surface = .TRUE.
-       
 
  10    CONTINUE
@@ -2879,5 +3473,5 @@
         IMPLICIT NONE
        
-        INTEGER(iwp)               :: i, j, k, kk, is, js, d, ku, refstep
+        INTEGER(iwp)               :: i, j, k, kk, is, js, d, ku, refstep, m, mm, l, ll
         INTEGER(iwp)               :: nzubl, nzutl, isurf, isurfsrc, isurf1, isvf, icsf, ipcgb
         INTEGER(iwp), DIMENSION(4) :: bdycross
@@ -2892,4 +3486,5 @@
         REAL(wp)                   :: pc_box_area, pc_abs_frac, pc_abs_eff
         INTEGER(iwp)               :: pc_box_dimshift !< transform for best accuracy
+        INTEGER(iwp), DIMENSION(0:3) :: reorder = (/ 1, 0, 3, 2 /)
         
         
@@ -2949,23 +3544,55 @@
 !--     First pass: direct + diffuse irradiance
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        surfinswdir   = 0._wp
-        surfinswdif   = 0._wp
-        surfinlwdif   = 0._wp
-        surfins   = 0._wp
-        surfinl   = 0._wp
-        surfoutsl    = 0._wp
-        surfoutll    = 0._wp
+        surfinswdir   = 0._wp !nsurfl
+        surfinswdif   = 0._wp !nsurfl
+        surfinlwdif   = 0._wp !nsurfl
+        surfins       = 0._wp !nsurfl
+        surfinl       = 0._wp !nsurfl
+        surfoutsl(:)  = 0.0_wp !start-end
+        surfoutll(:)  = 0.0_wp !start-end
         
 !--     Set up thermal radiation from surfaces
 !--     emiss_surf is defined only for surfaces for which energy balance is calculated
-        surfoutll(startenergy:endenergy) = emiss_surf(startenergy:endenergy) * sigma_sb   &
-                                           * t_surf(startenergy:endenergy)**4
+!--     Workaround: reorder surface data type back on 1D array including all surfaces, 
+!--     which implies to reorder horizontal and vertical surfaces
+!
+!--     Horizontal walls
+        mm = 1
+        DO  i = nxl, nxr
+           DO  j = nys, nyn
+
+              DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                 surfoutll(mm) = surf_usm_h%emiss_surf(m) * sigma_sb   &
+                                     * t_surf_h(m)**4
+                 albedo_surf(mm) = surf_usm_h%albedo_surf(m)
+                 emiss_surf(mm)  = surf_usm_h%emiss_surf(m)
+                 mm = mm + 1
+              ENDDO
+           ENDDO
+        ENDDO
+!
+!--     Vertical walls
+        DO  i = nxl, nxr
+           DO  j = nys, nyn
+              DO  ll = 0, 3
+                 l = reorder(ll)
+                 DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
+                    surfoutll(mm) = surf_usm_v(l)%emiss_surf(m) * sigma_sb   &
+                                     * t_surf_v(l)%t(m)**4
+                    albedo_surf(mm) = surf_usm_v(l)%albedo_surf(m)
+                    emiss_surf(mm) = surf_usm_v(l)%emiss_surf(m)
+                    mm = mm + 1
+                 ENDDO
+              ENDDO
+           ENDDO
+        ENDDO
         
 #if defined( __parallel )
 !--     might be optimized and gather only values relevant for current processor
+        
         CALL MPI_AllGatherv(surfoutll, nenergy, MPI_REAL, &
-                            surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+                            surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr) !nsurf global
 #else
-        surfoutl(:) = surfoutll(:)
+        surfoutl(:) = surfoutll(:) !nsurf global
 #endif
         
@@ -3005,8 +3632,8 @@
                 surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
             ENDIF
-            
-            IF ( zenith(0) > 0  .AND.  all( surf(:, isurfsrc) == bdycross ) )  THEN
+
+            IF ( zenith(0) > 0  .AND.  all( surf(1:4,isurfsrc) == bdycross ) )  THEN
 !--             found svf between model boundary and the face => face isn't shaded
-                surfinswdir(isurf) = rad_sw_in_dir(j, i) &
+                surfinswdir(isurf) = rad_sw_in_dir(j,i) &
                     * costheta(surfl(id, isurf)) * svf(2,isvf) / zenith(0)
 
@@ -3050,5 +3677,5 @@
                 ENDIF
 
-                IF ( zenith(0) > 0  .AND.  all( surf(:, isurfsrc) == bdycross ) )  THEN
+                IF ( zenith(0) > 0  .AND.  all( surf(1:4,isurfsrc) == bdycross ) )  THEN
 !--                 found svf between model boundary and the pcgb => pcgb isn't shaded
                     pc_abs_frac = 1._wp - exp(pc_abs_eff * lad_s(k,j,i))
@@ -3058,4 +3685,5 @@
             ENDDO
         ENDIF
+
         surfins(startenergy:endenergy) = surfinswdir(startenergy:endenergy) + surfinswdif(startenergy:endenergy)
         surfinl(startenergy:endenergy) = surfinl(startenergy:endenergy) + surfinlwdif(startenergy:endenergy)
@@ -3064,6 +3692,6 @@
         surfoutsw(:) = 0.0_wp
         surfoutlw(:) = surfoutll(:)
-        surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
-                                      - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
+!         surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
+!                                       - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
         
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -3117,6 +3745,6 @@
             surfoutsw(startenergy:endenergy) = surfoutsw(startenergy:endenergy) + surfoutsl(startenergy:endenergy)
             surfoutlw(startenergy:endenergy) = surfoutlw(startenergy:endenergy) + surfoutll(startenergy:endenergy)
-            surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
-                                          - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
+!             surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
+!                                           - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
         
         ENDDO
@@ -3129,9 +3757,72 @@
                 i = pcbl(ix, ipcgb)
                 k = pcbl(iz, ipcgb)
-                kk = k - nzb_s_inner(j,i)  !- lad arrays are defined flat
+                kk = k - MAXLOC(                                               &
+                                MERGE( 1, 0,                                   &
+                                       BTEST( wall_flags_0(:,j,i), 12 )        &
+                                     ), DIM = 1                                &
+                               ) - 1 ! kk = k - nzb_s_inner(j,i)  !- lad arrays are defined flat
                 pc_heating_rate(kk, j, i) = (pcbinsw(ipcgb) + pcbinlw(ipcgb)) &
                     * pchf_prep(k) * pt(k, j, i) !-- = dT/dt
             ENDDO
         ENDIF
+!
+!--     Transfer radiation arrays required for energy balance to the respective data types
+        DO  i = startenergy, endenergy
+           m  = surfl(5,i)          
+!
+!--        upward-facing
+           IF ( surfl(1,i) == 0 )  THEN
+              surf_usm_h%rad_in_sw(m)  = surfinsw(i) 
+              surf_usm_h%rad_out_sw(m) = surfoutsw(i) 
+              surf_usm_h%rad_in_lw(m)  = surfinlw(i)
+              surf_usm_h%rad_out_lw(m) = surfoutlw(i)
+!
+!--        southward-facding
+           ELSEIF ( surfl(1,i) == 1 )  THEN
+              surf_usm_v(1)%rad_in_sw(m)  = surfinsw(i) 
+              surf_usm_v(1)%rad_out_sw(m) = surfoutsw(i) 
+              surf_usm_v(1)%rad_in_lw(m)  = surfinlw(i)
+              surf_usm_v(1)%rad_out_lw(m) = surfoutlw(i)
+!
+!--        northward-facding
+           ELSEIF ( surfl(1,i) == 2 )  THEN
+              surf_usm_v(0)%rad_in_sw(m)  = surfinsw(i) 
+              surf_usm_v(0)%rad_out_sw(m) = surfoutsw(i) 
+              surf_usm_v(0)%rad_in_lw(m)  = surfinlw(i)
+              surf_usm_v(0)%rad_out_lw(m) = surfoutlw(i)
+!
+!--        westward-facding
+           ELSEIF ( surfl(1,i) == 3 )  THEN
+              surf_usm_v(3)%rad_in_sw(m)  = surfinsw(i) 
+              surf_usm_v(3)%rad_out_sw(m) = surfoutsw(i) 
+              surf_usm_v(3)%rad_in_lw(m)  = surfinlw(i)
+              surf_usm_v(3)%rad_out_lw(m) = surfoutlw(i)
+!
+!--        eastward-facing
+           ELSEIF ( surfl(1,i) == 4 )  THEN
+              surf_usm_v(2)%rad_in_sw(m)  = surfinsw(i) 
+              surf_usm_v(2)%rad_out_sw(m) = surfoutsw(i) 
+              surf_usm_v(2)%rad_in_lw(m)  = surfinlw(i)
+              surf_usm_v(2)%rad_out_lw(m) = surfoutlw(i)
+           ENDIF
+
+        ENDDO
+
+
+        DO  m = 1, surf_usm_h%ns
+           surf_usm_h%surfhf(m) = surf_usm_h%rad_in_sw(m)  +                   &
+                                  surf_usm_h%rad_in_lw(m)  -                   &
+                                  surf_usm_h%rad_out_sw(m) -                   &
+                                  surf_usm_h%rad_out_lw(m)
+        ENDDO
+
+        DO  l = 0, 3
+           DO  m = 1, surf_usm_v(l)%ns
+              surf_usm_v(l)%surfhf(m) = surf_usm_v(l)%rad_in_sw(m)  +          &
+                                        surf_usm_v(l)%rad_in_lw(m)  -          &
+                                        surf_usm_v(l)%rad_out_sw(m) -          &
+                                        surf_usm_v(l)%rad_out_lw(m)
+           ENDDO
+        ENDDO
 
 !--     return surface radiation to horizontal surfaces 
@@ -3207,5 +3898,5 @@
         REAL(wp), PARAMETER                    :: grow_factor = 1.5_wp !< factor of expansion of grow arrays
 
-
+!
 !--     Maximum number of gridboxes visited equals to maximum number of boundaries crossed in each dimension plus one. That's also
 !--     the maximum number of plant canopy boxes written. We grow the acsf array accordingly using exponential factor.
@@ -3351,5 +4042,4 @@
         visible = .TRUE.
 
-        
     END SUBROUTINE usm_raytrace
     
@@ -3470,24 +4160,103 @@
                 SELECT CASE ( TRIM( variable_chr ) )
                 
-                   CASE ( 't_surf' )
+                   CASE ( 't_surf_h' )
 #if defined( __nopointer )                   
-                      IF ( .NOT.  ALLOCATED( t_surf ) )                         &
-                         ALLOCATE( t_surf(startenergy:endenergy) )
-                      READ ( 13 )  t_surf
+                      IF ( .NOT.  ALLOCATED( t_surf_h ) )                      &
+                         ALLOCATE( t_surf_h(1:surf_usm_h%ns) )
+                      READ ( 13 )  t_surf_h
 #else                      
-                      IF ( .NOT.  ALLOCATED( t_surf_1 ) )                         &
-                         ALLOCATE( t_surf_1(startenergy:endenergy) )
-                      READ ( 13 )  t_surf_1
+                      IF ( .NOT.  ALLOCATED( t_surf_h_1 ) )                    &
+                         ALLOCATE( t_surf_h_1(1:surf_usm_h%ns) )
+                      READ ( 13 )  t_surf_h_1
 #endif
-
-                   CASE ( 't_wall' )
+                   CASE ( 't_surf_v(0)' )
+#if defined( __nopointer )                   
+                      IF ( .NOT.  ALLOCATED( t_surf_v(0)%t ) )                 &
+                         ALLOCATE( t_surf_v(0)%t(1:surf_usm_v(0)%ns) )
+                      READ ( 13 )  t_surf_v(0)%t
+#else                      
+                      IF ( .NOT.  ALLOCATED( t_surf_v_1(0)%t ) )               &
+                         ALLOCATE( t_surf_v_1(0)%t(1:surf_usm_v(0)%ns) )
+                      READ ( 13 )  t_surf_v_1(0)%t
+#endif
+                   CASE ( 't_surf_v(1)' )
+#if defined( __nopointer )                   
+                      IF ( .NOT.  ALLOCATED( t_surf_v(1)%t ) )                 &
+                         ALLOCATE( t_surf_v(1)%t(1:surf_usm_v(1)%ns) )
+                      READ ( 13 )  t_surf_v(1)%t
+#else                      
+                      IF ( .NOT.  ALLOCATED( t_surf_v_1(1)%t ) )               &
+                         ALLOCATE( t_surf_v_1(1)%t(1:surf_usm_v(1)%ns) )
+                      READ ( 13 )  t_surf_v_1(1)%t
+#endif
+                   CASE ( 't_surf_v(2)' )
+#if defined( __nopointer )                   
+                      IF ( .NOT.  ALLOCATED( t_surf_v(2)%t ) )                 &
+                         ALLOCATE( t_surf_v(2)%t(1:surf_usm_v(2)%ns) )
+                      READ ( 13 )  t_surf_v(2)%t
+#else                      
+                      IF ( .NOT.  ALLOCATED( t_surf_v_1(2)%t ) )               &
+                         ALLOCATE( t_surf_v_1(2)%t(1:surf_usm_v(2)%ns) )
+                      READ ( 13 )  t_surf_v_1(2)%t
+#endif
+                   CASE ( 't_surf_v(3)' )
+#if defined( __nopointer )                   
+                      IF ( .NOT.  ALLOCATED( t_surf_v(3)%t ) )                 &
+                         ALLOCATE( t_surf_v(3)%t(1:surf_usm_v(3)%ns) )
+                      READ ( 13 )  t_surf_v(3)%t
+#else                      
+                      IF ( .NOT.  ALLOCATED( t_surf_v_1(3)%t ) )               &
+                         ALLOCATE( t_surf_v_1(3)%t(1:surf_usm_v(3)%ns) )
+                      READ ( 13 )  t_surf_v_1(3)%t
+#endif
+                   CASE ( 't_wall_h' )
 #if defined( __nopointer )
-                      IF ( .NOT.  ALLOCATED( t_wall ) )                         &
-                         ALLOCATE( t_wall(nzb_wall:nzt_wall+1,startenergy:endenergy) )
-                      READ ( 13 )  t_wall
+                      IF ( .NOT.  ALLOCATED( t_wall_h ) )                      &
+                         ALLOCATE( t_wall_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+                      READ ( 13 )  t_wall_h
 #else
-                      IF ( .NOT.  ALLOCATED( t_wall_1 ) )                         &
-                         ALLOCATE( t_wall_1(nzb_wall:nzt_wall+1,startenergy:endenergy) )
-                      READ ( 13 )  t_wall_1
+                      IF ( .NOT.  ALLOCATED( t_wall_h_1 ) )                    &
+                         ALLOCATE( t_wall_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+                      READ ( 13 )  t_wall_h_1
+#endif
+                   CASE ( 't_wall_v(0)' )
+#if defined( __nopointer )
+                      IF ( .NOT.  ALLOCATED( t_wall_v(0)%t ) )                      &
+                         ALLOCATE( t_wall_v(0)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(0)%ns) )
+                      READ ( 13 )  t_wall_v(0)%t
+#else
+                      IF ( .NOT.  ALLOCATED( t_wall_v_1(0)%t ) )                    &
+                         ALLOCATE( t_wall_v_1(0)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(0)%ns) )
+                      READ ( 13 )  t_wall_v_1(0)%t
+#endif
+                   CASE ( 't_wall_v(1)' )
+#if defined( __nopointer )
+                      IF ( .NOT.  ALLOCATED( t_wall_v(1)%t ) )                      &
+                         ALLOCATE( t_wall_v(1)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(1)%ns) )
+                      READ ( 13 )  t_wall_v(1)%t
+#else
+                      IF ( .NOT.  ALLOCATED( t_wall_v_1(0)%t ) )                    &
+                         ALLOCATE( t_wall_v_1(1)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(1)%ns) )
+                      READ ( 13 )  t_wall_v_1(1)%t
+#endif
+                   CASE ( 't_wall_v(2)' )
+#if defined( __nopointer )
+                      IF ( .NOT.  ALLOCATED( t_wall_v(2)%t ) )                      &
+                         ALLOCATE( t_wall_v(2)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(2)%ns) )
+                      READ ( 13 )  t_wall_v(2)%t
+#else
+                      IF ( .NOT.  ALLOCATED( t_wall_v_1(2)%t ) )                    &
+                         ALLOCATE( t_wall_v_1(2)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(2)%ns) )
+                      READ ( 13 )  t_wall_v_1(2)%t
+#endif
+                   CASE ( 't_wall_v(3)' )
+#if defined( __nopointer )
+                      IF ( .NOT.  ALLOCATED( t_wall_v(3)%t ) )                      &
+                         ALLOCATE( t_wall_v(3)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(3)%ns) )
+                      READ ( 13 )  t_wall_v(3)%t
+#else
+                      IF ( .NOT.  ALLOCATED( t_wall_v_1(3)%t ) )                    &
+                         ALLOCATE( t_wall_v_1(3)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(3)%ns) )
+                      READ ( 13 )  t_wall_v_1(3)%t
 #endif
 
@@ -3593,5 +4362,5 @@
         INTEGER(iwp), DIMENSION(0:17, nysg:nyng, nxlg:nxrg)   :: usm_par
         REAL(wp), DIMENSION(1:14, nysg:nyng, nxlg:nxrg)       :: usm_val
-        INTEGER(iwp)                                          :: k, l, d, iw, jw, kw, it, ip, ii, ij
+        INTEGER(iwp)                                          :: k, l, d, iw, jw, kw, it, ip, ii, ij, m
         INTEGER(iwp)                                          :: i, j
         INTEGER(iwp)                                          :: nz, roof, dirwe, dirsn
